searchNodes=[{"doc":"Tesla middleware for converting the request and response body keys. This middleware will convert all the keys from the request body using the function defined in the options before executing the request, and will convert all the keys from the response body using the function defined in options after getting the response Examples defmodule MyClient do use Tesla plug TeslaKeys.Middleware.Case # use defaults # or plug TeslaKeys.Middleware.Case , encoder : &amp; Recase . to_camel / 1 , serializer : &amp; Recase.Enumerable . atomize_keys / 2 # or plug TeslaKeys.Middleware.Case , encoder : &amp; String . upcase / 1 , serializer : &amp; serializer / 2 defp serializer ( data , encoder ) when is_map ( data ) , do : Map . new ( data , fn { key , value } -&gt; { then ( key , encoder ) , value } end ) defp serializer ( data , encoder ) when is_list ( data ) , do : Enum . map ( data , &amp; serializer ( &amp;1 , encoder ) ) defp serializer ( data , _encoder ) , do : data end Options :serializer - serializer function with arity 2, receives the data as the first parameter and the :encoder as the second parameter, (defaults to &amp;Recase.Enumerable.stringify_keys/2 ) :encoder - encoding function, e.g &amp;Recase.to_camel/1 , &amp;Recase.to_pascal/1 (defaults to &amp;Recase.to_camel/1 ) :decoder - decoding function (defaults to &amp;Recase.to_snake/1 )","ref":"TeslaKeys.Middleware.Case.html","title":"TeslaKeys.Middleware.Case","type":"module"},{"doc":"Tesla Middleware for remapping the body keys of the request and response. This middlware will convert all the keys of the body by their respective relation defined in the options before sending the request and after receiving the response Examples defmodule MyClient do use Tesla plug TeslaKeys.Middleware.Remapper , keys : %{ # key expected by API =&gt; key you want to handle instead &quot;pong&quot; =&gt; &quot;ping&quot; , &quot;bar&quot; =&gt; &quot;foo&quot; , &quot;bye&quot; =&gt; &quot;hey&quot; } end Options :keys - relation of keys expected by the API and that you want to handle","ref":"TeslaKeys.Middleware.Remapper.html","title":"TeslaKeys.Middleware.Remapper","type":"module"},{"doc":"Aggregate of useful middlewares to manipulate body keys","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"The package can be installed by adding tesla_keys to your list of dependencies in mix.exs : def deps do [ { :tesla_keys , &quot;~&gt; 0.1&quot; } ] end Examples You can find usage examples in the Guides section.","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"","ref":"usage.html","title":"Usage","type":"extras"},{"doc":"First of all, we need to install tesla_keys and all dependencies to work with tesla : Mix . install ( ~w[tesla tesla_keys jason]a )","ref":"usage.html#setup","title":"Usage - Setup","type":"extras"},{"doc":"Let's create an HTTP client to consume the {JSON} Placeholder fake API. To learn more about it, see the guide . defmodule Client do use Tesla plug Tesla.Middleware.BaseUrl , &quot;https://jsonplaceholder.typicode.com/&quot; # middleware for remapping request and response body keys plug TeslaKeys.Middleware.Remapper , keys : [ body : :content ] # middleware for converting request and response body keys plug TeslaKeys.Middleware.Case , serializer : &amp; Recase.Enumerable . atomize_keys / 2 plug Tesla.Middleware.Logger plug Tesla.Middleware.PathParams plug Tesla.Middleware.JSON def list_posts ( ) do get ( &quot;/posts&quot; ) end def update_post ( id , body ) do params = [ id : id ] put ( &quot;/posts/:id&quot; , body , opts : [ path_params : params ] ) end end In the example above, the {JSON} Placeholder expects the post body to have the following structure: { &quot;id&quot;: 1, &quot;title&quot;: &quot;...&quot;, &quot;body&quot;: &quot;...&quot;, &quot;userId&quot;: 1 } But when we use the TeslaKeys plugs to handle our request and response, we make some changes to the body data along the way, getting the following structure relative to the previous one: %{ id : 1 , title : &quot;...&quot; , content : &quot;...&quot; , user_id : 1 } So if you run the following request, everything works as expected: params = %{ title : &quot;foo&quot; , content : &quot;bar&quot; , user_id : 1 } with { :ok , %{ body : body } } &lt;- Client . update_post ( 1 , params ) do body end","ref":"usage.html#using","title":"Usage - Using","type":"extras"}]